package emulatorinterface.translator.visaHandler;

import emulatorinterface.DynamicInstructionBuffer;
import generic.Instruction;

public class Jump implements DynamicInstructionHandler 
{
	public int handle(int microOpIndex, 
			Instruction microOp, DynamicInstructionBuffer dynamicInstructionBuffer) 
	{
		long branchAddress = dynamicInstructionBuffer.getBranchAddress(microOp.getCISCProgramCounter());
		
		if(branchAddress != -1)
		{
			microOp.setBranchTaken(true);
			microOp.setBranchTargetAddress(branchAddress);
			
			return ++microOpIndex;
		}
		else
		{
			return -1;
		}
		
	}
}