package generic;

import java.util.ArrayList;
import java.util.Vector;

import main.ArchitecturalComponent;
import main.Main;
import memorysystem.Cache;
import config.SystemConfig;

public class ClockDomain {

	int id;
	long currentTime;
	int stepSize;
	public int previousPhase=-1;

	public ClockDomain(int javaId) {
		id = javaId;
		currentTime = 0;
		stepSize = 1;
	}

	public static void systemTimingSetUp(ArrayList<Core> cores, ArrayList<Cache> cacheList, ArrayList<Cache> sharedCacheList)
	{
		int i = 0;

		int[] freq_list = new int[SystemConfig.NoOfCores /*+ cacheList.size() + sharedCacheList.size() */+ 1];

		for(i = 0; i < SystemConfig.NoOfCores; i++)
		{
			freq_list[i] = Math.round(cores.get(i).getFrequency()/100);
		}
		freq_list[i] = Math.round(SystemConfig.mainMemoryFrequency/100);
			
		int j;
		boolean flag = false;
		boolean HCFFound = false;
		int HCF = 1;
		for(i = 1; ; i++)
		{
			flag = true;
			for(j = 0; j < SystemConfig.NoOfCores /*+ cacheList.size() + sharedCacheList.size()*/ + 1; j++)
			{
				if(freq_list[j]%i != 0)
				{
					flag = false;
					break;
				}

				if(freq_list[j] == i)
				{
					HCFFound = true;
				}					
			}

			if(flag == true)
			{
				HCF = i;
			}

			if(HCFFound == true)
				break;
		}

		System.out.println("HCF = " + HCF);

		for(i = 0; i < SystemConfig.NoOfCores + /*cacheList.size() + sharedCacheList.size() + */1; i++)
		{
			freq_list[i] = freq_list[i]/HCF;
		}

		int LCM, cur = freq_list[0];

		while(true)
		{
			flag = true;
			for(i = 0; i < SystemConfig.NoOfCores + /*cacheList.size() + sharedCacheList.size() + */1; i++)
			{
				//System.out.println("----------------"+freq_list[i]+"-----------------");
				if(cur%freq_list[i] != 0)
				{
					flag = false;
					break;
				}
			}
			if(flag == true)
			{
				LCM = cur;
				break;
			}
			cur = cur + freq_list[0];
		}

		System.out.println("LCM = " + LCM);

		//set step sizes of components
		for(i = 0; i < SystemConfig.NoOfCores; i++)
		{
			ArchitecturalComponent.cores.get(i).setStepSize(1);
		}
	}

	public long getCurrentTime() {
		return this.currentTime;
	}

	public void setCurrentTime(long currentTime) {
		this.currentTime = currentTime;
	}

	public void incrementClock()
	{
		//Step size must be 1 for clockdomain
		this.currentTime += this.stepSize;
		if (currentTime % Main.SynchClockDomainsCycles ==0) {
		//	int phase = Main.barrierClocks.getPhase(); 
			//if (phase==previousPhase) {
				//System.out.println(id + "CD1");
				//System.out.println(id + ": in phase = " + previousPhase);
				//Main.barrierClocks.awaitAdvance(phase);
				Main.barrierClocks.arriveAndAwaitAdvance();
			//	System.out.println(id + "CD2");
			//}
			//previousPhase = Main.barrierClocks.arrive();
			//System.out.println(id + ": Reached phase = " + previousPhase);
			
			
		}
	}

	public int getStepSize() {
		return this.stepSize;
	}

	public void setStepSize(int stepSize) {
		this.stepSize = 1;
	}

}
